/*******************************************************************************
 * Copyright (c) 2004 Berthold Daum. All rights reserved. This program and the
 * accompanying materials are made available under the terms of the Common
 * Public License v1.0 which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/cpl-v10.html
 * 
 * Contributors: Berthold Daum
 ******************************************************************************/

package com.sun.speech.freetts.relp;

import com.sun.speech.freetts.ProcessException;
import com.sun.speech.freetts.Utterance;
import com.sun.speech.freetts.UtteranceProcessor;

/**
 * @author Berthold Daum
 *
 * Creation date: 01.10.2003
 * 
 */
public class AnimatedAudioOutput extends AudioOutput {

	UtteranceProcessor animator;

	/**
	 * Method AnimatedAudioOutput.
	 * @param animator Animator object for generating animation events
	 */
	public AnimatedAudioOutput(UtteranceProcessor animator) {
		// Initialize animator field
		this.animator = animator;
	}

	/**
	 * @see com.sun.speech.freetts.UtteranceProcessor#
	 * processUtterance(Utterance)
	 */
	public void processUtterance(Utterance u) throws ProcessException {
		// In case we got an Animator we invoke its 
		// processUtterance method.
		if (animator != null) 
			animator.processUtterance(u);
		// Then proceed as usual
		super.processUtterance(u);
	}
} 